<?php

/***************************************************************
*  Copyright notice
*
*  (c) 2005 Thomas Off, LumoNet oHG (t.off@lumonet.de)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

/**
 * Plugin 'PHP Include' for the 'lumophpinclude' extension.
 *
 * @author	Thomas Off, LumoNet oHG <t.off@lumonet.de>
 */

require_once(PATH_tslib.'class.tslib_pibase.php');

class tx_lumophpinclude_pi1 extends tslib_pibase {
	var $prefixId = 'tx_lumophpinclude_pi1';			// Same as class name
	var $scriptRelPath = 'pi1/class.tx_lumophpinclude_pi1.php';	// Path to this script relative to the extension dir.
	var $extKey = 'lumophpinclude';	// The extension key.

	/**
	 * Get configuration options from the flexform.
  	 */
	function init() {
		$this->pi_initPIflexForm();	// Init and get the flexform data of the plugin.
		$piFlexForm = $this->cObj->data['pi_flexform'];	// Assign the flexform data to a local variable for easier access.

		// Get the configuration values from flexform.
		$this->lConf['transfer_get'] = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'transfer_get', 'sDEF');
		$this->lConf['transfer_post'] = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'transfer_post', 'sDEF');
		$this->lConf['transfer_cookies'] = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'transfer_cookies', 'sDEF');
		$this->lConf['script_type'] = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'script_type', 'sDEF');
		$this->lConf['script_file'] = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'script_file', 'sDEF');
		$this->lConf['script_url'] = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'script_url', 'sDEF');
		$this->lConf['header_strip'] = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'header_strip', 'sDEF');
		$this->lConf['footer_strip'] = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'footer_strip', 'sDEF');
	}

	/**
	 * Main function.
	 */
	function main($content, $conf) {
		$this->conf = $conf;
		$this->pi_setPiVarDefaults();
		$this->pi_loadLL();
		$this->pi_USER_INT_obj = 1;	// Configuring so caching is not expected. This value means that no cHash params are ever set. We do this, because it's a USER_INT object!

		// Read FlexForm data.
		$this->init();

		// Initialize content variable.
		$content = '';

		if ($this->lConf['script_type'] == 'file') {	// Local script will be included.

			// Put GET parameters into an array.
			$getvars = array();
			if ($this->lConf['transfer_get']) {
				foreach ($_GET as $key => $val) {
					$getvars[$key] = $val;
				}
			}

			// Put POST parameters into an array.
			$postvars = array();
			if ($this->lConf['transfer_post']) {
				foreach ($_POST as $key => $val) {
					$postvars[$key] = $val;
				}
			}

			// Put POST parameters into an array.
			$cookievars = array();
			if ($this->lConf['transfer_cookies']) {
				foreach ($_COOKIE as $key => $val) {
					$cookievars[$key] = $val;
				}
			}

			// Get script content.
			$script_content = $this->cObj->fileResource('uploads/' . $this->lConf['script_file']);

			// Remove PHP start and end tags from script content.
			$script_content = preg_replace('/<\?php/', '', $script_content);
			$script_content = preg_replace('/\?>/', '', $script_content);

			// Start output buffering.
			ob_start();

			// Evaluate included code.
			eval($script_content);

			// Get output from evaluated code.
			$content = ob_get_contents();

			// End output buffering and clean buffer.
			ob_end_clean();

		}
		else {	// Remote script will be included via HTTP.

			// Turn GET parameters into single string.
			$temp_getvars = '';
			if ($this->lConf['transfer_get']) {
				foreach ($_GET as $key => $val) {
					if (is_array($val)) {
						$i = 0;
						foreach ($val as $key2 => $val2) {
							$temp_getvars .= $key . '[]' . '=' . urlencode($val2) . '&';
							$i++;
						}
					}
					else {
						$temp_getvars .= $key . '=' . urlencode($val) . '&';
					}
				}
			}

			// Turn POST parameters into single string.
			$temp_postvars = '';
			if ($this->lConf['transfer_post']) {
				foreach ($_POST as $key => $val) {
					if (is_array($val)) {
						$i = 0;
						foreach ($val as $key2 => $val2) {
							$temp_postvars .= $key . '[]' . '=' . urlencode($val2) . '&';
							$i++;
						}
					}
					else {
						$temp_postvars .= $key . '=' . urlencode($val) . '&';
					}
				}
			}

			// Turn cookie data into single string.
			$temp_cookievars = '';
			if ($this->lConf['transfer_cookies']) {
				foreach ($_COOKIE as $key => $val) {
					if (is_array($val)) {
						$i = 0;
						foreach ($val as $key2 => $val2) {
							$temp_cookievars .= $key . '[]' . '=' . urlencode($val2) . '&';
							$i++;
						}
					}
					else {
						$temp_cookievars .= $key . '=' . urlencode($val) . '&';
					}
				}
			}

			// Compose GET and POST parameter and cookie data into one string.
			$params = '';
			if ($temp_getvars != '') {
				$params .= ($params == '' ? '' : '&') . $temp_getvars;
			}
			if ($temp_postvars != '') {
				$params .= ($params == '' ? '' : '&') . $temp_postvars;
			}
			if ($temp_cookievars != '') {
				$params .= ($params == '' ? '' : '&') . $temp_cookievars;
			}

			// Compose URL of script to include.
			$url = $this->lConf['script_url'];
			$url .= ($params == '' ? '' : ((strstr($url, '?') ? '&' : '?') . $params));

			// Include script.
			$content = file_get_contents($url);

		}

		// Strip header and footer if marker are set in flexform.
		if ($this->lConf['header_strip'] != '') {
			$content = preg_replace('/.*?<!-- ' . $this->lConf['header_strip'] . ' -->/s', '$1', $content);
		}
		if ($this->lConf['footer_strip'] != '') {
			$content = preg_replace('/<!-- ' . $this->lConf['footer_strip'] . ' -->.*/s', '$1', $content);
		}

		// Replace special markers.
		$page_id = $GLOBALS['TSFE']->id;
		$content = preg_replace('/###PID###/', $page_id, $content);

		// Return content from script.
		return $this->pi_wrapInBaseClass($content);
	}
}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/lumophpinclude/pi1/class.tx_lumophpinclude_pi1.php']) {
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/lumophpinclude/pi1/class.tx_lumophpinclude_pi1.php']);
}

?>
